
#include <delay_ms.h>
#include <paulmon2.h>

xdata at 0x4000 unsigned char p82c55_port_a;
xdata at 0x4001 unsigned char p82c55_port_b;
xdata at 0x4002 unsigned char p82c55_port_c;
xdata at 0x4003 unsigned char p82c55_config;

#define VERBOSE

code unsigned char pattern_table[] = {
0x7F, /* 01111111 */
0x3F, /* 00111111 */
0x1F, /* 00011111 */
0x8F, /* 10001111 */
0xC7, /* 11000111 */
0xE3, /* 11100011 */
0xF1, /* 11110001 */
0xF8, /* 11111000 */
0xFC, /* 11111100 */
0xFE, /* 11111110 */
0xFC, /* 11111100 */
0xF8, /* 11111000 */
0xF1, /* 11110001 */
0xE3, /* 11100011 */
0xC7, /* 11000111 */
0x8F, /* 10001111 */
0x1F, /* 00011111 */
0x3F, /* 00111111 */
255};

code unsigned char delay_table[] = {
90,
70,
50,
40,
40,
40,
40,
50,
70,
90,
70,
50,
40,
40,
40,
40,
50,
70,
0};

void main()
{
	unsigned char i=0;

	p82c55_config = 128;	/* all ports outputs */

	while (1) {
		if (delay_table[i] > 0) {
			p82c55_port_c = pattern_table[i];
			delay_ms(delay_table[i]);
#ifdef VERBOSE
			pm2_pstr("Pattern=0x");
			pm2_phex(pattern_table[i]);
			pm2_pstr(" for delay=");
			pm2_pint8u(delay_table[i]);
			pm2_newline();
#endif
			i++;
		} else {
			i = 0;
		}
		if (pm2_esc()) pm2_restart();
	}
}


